# -*- coding: utf-8 -*-
"""
Created on DEC 22  15:37:26 2020

@author: Dell
"""


from keras import backend as K


K.clear_session()
from keras.layers import Conv2D, MaxPooling2D, Dropout, Flatten, Dense, Activation,GlobalMaxPooling2D
from tensorflow.keras.models import Sequential
from tensorflow.keras.layers import BatchNormalization
from tensorflow.keras.layers import Conv2D
from tensorflow.keras.layers import MaxPooling2D
from tensorflow.keras.layers import Activation
from tensorflow.keras.layers import Flatten
from tensorflow.keras.layers import Dropout
from tensorflow.keras.layers import Dense
from tensorflow.keras import backend as K
import matplotlib
matplotlib.use("Agg")
from keras.models import Model
import tensorflow as tf
from keras import layers

import keras
from tensorflow.keras.preprocessing.image import ImageDataGenerator
from tensorflow.keras.optimizers import Adam
from tensorflow.keras.preprocessing.image import img_to_array
from sklearn.preprocessing import MultiLabelBinarizer
from sklearn.model_selection import train_test_split
#from pyimagesearch.smallervggnet import SmallerVGGNet
import matplotlib.pyplot as plt
from imutils import paths
from keras.utils import plot_model

from sklearn.metrics import precision_score
from sklearn.metrics import recall_score
from sklearn.metrics import f1_score
from sklearn.metrics import coverage_error
from sklearn.metrics import hamming_loss
from sklearn.metrics import average_precision_score
  

import numpy as np
#import argparse
from keras.preprocessing.image import load_img
import random
import pickle
import cv2
from keras.callbacks import Callback
import os
import itertools




from tensorflow.python.framework import ops
from tensorflow.python.ops import control_flow_ops
from tensorflow.python.ops import resource_variable_ops
from tensorflow.python.ops import state_ops
from tensorflow.python.training import adam
from tensorflow.python.training import momentum as momentum_opt
from tensorflow.python.training import optimizer
from tensorflow.python.util.tf_export import tf_export
from tensorflow.python.ops import array_ops


from keras.applications.vgg16 import VGG16
model = VGG16()
print(model.summary())


class SVGGNet:
	@staticmethod
	def build(width, height, depth, classes, actFunc="softmax"):
		# initialize the model along with the input shape to be
		# "channels last" and the channels dimension itself
		model = Sequential()
		inputShape = (height, width, depth)
		chanDim = -1
		# if we are using "channels first", update the input shape
		# and channels dimension
		if K.image_data_format() == "channels_first":
			inputShape = (depth, height, width)
			chanDim = 1
            
        # CONV => RELU => POOL
		model.add(Conv2D(32, (3, 3), padding="same",
			input_shape=inputShape))
		model.add(Activation("relu"))
		model.add(BatchNormalization(axis=chanDim))
		model.add(MaxPooling2D(pool_size=(3, 3)))
		model.add(Dropout(0.25))
		
		model.add(Conv2D(64, (3, 3), padding="same"))
		model.add(Activation("relu"))
		model.add(BatchNormalization(axis=chanDim))
		model.add(Conv2D(64, (3, 3), padding="same"))
		model.add(Activation("relu"))
		model.add(BatchNormalization(axis=chanDim))
		model.add(MaxPooling2D(pool_size=(2, 2)))
		model.add(Dropout(0.25))

		model.add(Conv2D(128, (3, 3), padding="same"))
		model.add(Activation("relu"))
		model.add(BatchNormalization(axis=chanDim))
		model.add(Conv2D(128, (3, 3), padding="same"))
		model.add(Activation("relu"))
		model.add(BatchNormalization(axis=chanDim))
		model.add(MaxPooling2D(pool_size=(2, 2)))
		model.add(Dropout(0.25))
		
		model.add(Flatten())
		model.add(Dense(1024))
		model.add(Activation("relu"))
		model.add(BatchNormalization())
		model.add(Dropout(0.5))
		# softmax classifier
		model.add(Dense(classes))
		model.add(Activation(actFunc))
		# return the constructed network architecture
		return model
        


EPOCHS = 30                   
INIT_LR = 1e-3
BS = 32
IMAGE_DIMS = (224, 224, 3)

print("[INFO] loading images...")
imagePaths = sorted(list(paths.list_images('pathTotheTrainingData')))
#print(imagePaths)
random.seed(42)
random.shuffle(imagePaths)
data = []
labels = []

# loop over the input images
for imagePath in imagePaths:
	# load the image, pre-process it, and store it in the data list
	image = cv2.imread(imagePath)
	image = cv2.resize(image, (IMAGE_DIMS[1], IMAGE_DIMS[0]))
	image = img_to_array(image)
	data.append(image)
	# extract set of class labels from the image path and update the
	# labels list
	l = label = imagePath.split(os.path.sep)[-2].split("_")
	labels.append(l)


data = np.array(data, dtype="float") / 255.0
labels = np.array(labels)
print("[INFO] data matrix: {} images ({:.2f}MB)".format(
	len(imagePaths), data.nbytes / (1024 * 1000.0)))



# binarize the labels using scikit-learn's special multi-label
# binarizer implementation
print("[INFO] class labels:")
mlb = MultiLabelBinarizer()
labels = mlb.fit_transform(labels)
# loop over each of the possible class labels and show them
for (i, label) in enumerate(mlb.classes_):
	print("{}. {}".format(i + 1, label))


(trainX, testX, trainY, testY) = train_test_split(data,
	labels, test_size=0.2, random_state=42)


pretrained_model = VGG16(input_shape=(IMAGE_DIMS[1], IMAGE_DIMS[0], 3), include_top=False, weights="imagenet")
pretrained_model.summary()
 
# Freezing the layers
for layer in pretrained_model.layers[:15]:
    layer.trainable = False
for layer in pretrained_model.layers[15:]:
    layer.trainable = True
 
# Modification of pretrained model
last_layer = pretrained_model.get_layer('block5_pool')
last_output = last_layer.output
 
x = GlobalMaxPooling2D()(last_output)
x = Dense(1024, activation='relu')(x)
x = Dropout(0.5)(x)
x = layers.Dense(10, activation='sigmoid')(x)
 
# Creating a new model
model = Model(pretrained_model.input, x)


    

print("[INFO] compiling model...")
#model = SVGGNet.build(
#	width=IMAGE_DIMS[1], height=IMAGE_DIMS[0],
#	depth=IMAGE_DIMS[2], classes=len(mlb.classes_),
#	actFunc="sigmoid")
opt = Adam(lr=INIT_LR, decay=INIT_LR / EPOCHS)

model.compile(loss=["binary_crossentropy"], optimizer=opt,
	metrics=["accuracy"])
# train the network
print("[INFO] training network...")


History = model.fit(trainX, trainY, batch_size=BS,
	validation_data=(testX, testY),
    steps_per_epoch = len(trainX) // BS,
    epochs=EPOCHS,
    verbose = 0
            
    )

plt.style.use("ggplot")
plt.figure()
N = EPOCHS
plt.plot(np.arange(0, N), History.history["loss"], label="train_loss")
plt.plot(np.arange(0, N), History.history["val_loss"], label="val_loss")
plt.plot(np.arange(0, N), History.history["accuracy"], label="train_acc")
plt.plot(np.arange(0, N), History.history["val_accuracy"], label="val_acc")
plt.title("Training Loss and Accuracy")
plt.xlabel("Epoch #")
plt.ylabel("Loss/Accuracy")
plt.legend(loc="upper left")
plt.savefig('loss.pdf')


print("[INFO] loading images...")
imagePaths1 = sorted(list(paths.list_images('pathToTestData')))
#print(imagePaths)
random.seed(42)
random.shuffle(imagePaths1)
data1 = []
labels1 = []



for imagePath in imagePaths1:
	# load the image, pre-process it, and store it in the data list
	image = cv2.imread(imagePath)
	image = cv2.resize(image, (IMAGE_DIMS[1], IMAGE_DIMS[0]))
	image = img_to_array(image)
	data1.append(image)
	l = label = imagePath.split(os.path.sep)[-2].split("_")
	labels1.append(l)


data = np.array(data1, dtype="float") / 255.0
labels = np.array(labels1)
print("[INFO] data matrix: {} images ({:.2f}MB)".format(
	len(imagePaths), data.nbytes / (1024 * 1000.0)))

print("[INFO] class labels:")
mlb = MultiLabelBinarizer()
labels = mlb.fit_transform(labels)


for (i, label) in enumerate(mlb.classes_):
	print("{}. {}".format(i + 1, label))
    
X = data 
y = labels

# evaluation of the model with predict data
# iterate through the data and make predictions and collect 
#the predictions in a list for further evaluation 
y_prob = []
for k in range(len(X)):
    yPred_prob = model.predict(X)[k]
    yProb_classes = np.argsort(yPred_prob)[::-1][:2]
    prob = np.zeros(len(yPred_prob), dtype=int)
    prob = np.array(prob)
    for (i,j) in enumerate([yProb_classes]):
        prob[j]=1
    prob = list(prob)
    y_prob.append(prob)
y_prob = np.asarray(y_prob)


#the following metrics were used for the evaluation of the model
#Average_precision_score, precision_score, hamming_loss
# Ranking_loss, coverage_error

average_precision = average_precision_score(y, y_prob, average='weighted')
print('average_precision: %f', average_precision) 
precision = precision_score(y, y_prob, average='micro')
print("precision: %f", precision)

coverage = coverage_error(y, y_prob)
print('coverage: %f',coverage)

hamming = hamming_loss(y, y_prob)
print('hamming: %f',hamming)

ranking_loss = label_ranking_loss(y,y_prob)
print('ranking loss: %f', ranking_loss)


